; General String Routine testing procedure

;  All routine must have the same call, take same input and produce same output to be properly compared


TimesToLoop equ 10    ;  *** NOTE   This is all that is really needed to get consistant timings if these procedures are followed

; procs to test
Procs textequ <OVH>
; string lengths to test
Tests Textequ <1>
;Tests TEXTEQU < 1, 9, 18, 27,28,29, 36, 100, 401, 1000, 1001>   ; some of these bomb with zero length strings
;Tests TEXTEQU < 1, 2,3,4,5,29, 36, 100, 401, 1000, 1001>   ; some of these bomb with zero length strings
;Tests TEXTEQU < 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13>   ; some of these bomb with zero length strings
;Tests TEXTEQU <14,15,16,17,18,19,20,21,22,23,24,25,26>
;Tests TEXTEQU <27,28,29,30,31,32,33,34,35,36,37,38,39>
;Tests TEXTEQU <40,41,42,43,44,45,46,47,48,49,50,51,52>
;Tests TEXTEQU <53,54,55,56,57,58,59,60,61,62,63,64,65>
;Tests TEXTEQU <100,101,102,103,104,900,901,902,903,904,905,906,907>
;Tests TEXTEQU <5000,5001,5002,5003,5004,5005,5006,5007,5008,5009,5010,5011,5012>
PriClass textequ <REALTIME_PRIORITY_CLASS> ; priority to use for tests
;PriClass textequ <HIGH_PRIORITY_CLASS>
;PriClass textequ <NORMAL_PRIORITY_CLASS>   ; for debugging
    
.686p
.model  flat, stdcall
option  casemap :none   ; case sensitive
.nolist
include windows.inc
uselib  MACRO   libname
    include     libname.inc
    includelib  libname.lib
ENDM
uselib user32
uselib kernel32
uselib comctl32
uselib shell32

;uselib gdi32
;uselib comdlg32
uselib masm32
uselib debug
include macros.asm

inv equ Invoke

soff Macro QuotedText:Vararg    ; returns offset to a string
Local LocalText
.data
LocalText db QuotedText,0
.code
EXITM <offset LocalText>
Endm
.listall

.data?
align 16
StartingCycle dd ?
CyclePart2    dd ?
Loops         dd ?
ExtraLoops    dd ?
Min           dd ?
OverHead      dd ?   ; overhead of doing an empty proc
.code
BeginCounter macro  ; This macro is inserted before a block of test code
    align 16    ; just to be sure all code starts with equal advantage
    invoke GetCurrentProcess
    invoke SetPriorityClass, eax, PriClass  ; use the highest priority for all the tests
    invoke GetCurrentThread
    inv SetThreadPriority,eax,THREAD_PRIORITY_TIME_CRITICAL
            
    mov Min,9999999999
    mov Loops,TimesToLoop
    mov ExtraLoops,10   ; will do several times first to let things settle out
    inv Sleep,0
ExtraLoopsLoop = $
    sub ExtraLoops,1
TimingLoop = $
    mov [StartingCycle],eax     ; just to make sure they are in the cache
    mov [StartingCycle+4],eax
    Repeat 6    ; Intel says 4 but I've found that more works a little better
    xor eax,eax
    cpuid       ; call the EAX=0 version of CPUID to clear pipeline (serialize) (finish any pending instructions)
    Endm
    rdtsc
    mov [StartingCycle],eax
    mov [StartingCycle+4],edx
endm
EndCounter macro        ; This macro is inserted after each block of test code
    xor eax,eax
    cpuid       ; flush
    rdtsc
    cmp ExtraLoops,0
    jne ExtraLoopsLoop  ; skip first several iterations
    sub eax,[StartingCycle] ; get result in EDX:EAX
    sbb edx,[StartingCycle+4]
    cmp Min,eax
    jb @f
    mov Min,eax
@@:
    sub Loops,1
    jnz TimingLoop
    invoke GetCurrentThread
    inv SetThreadPriority,eax,THREAD_PRIORITY_NORMAL
    invoke GetCurrentProcess
    invoke SetPriorityClass, eax, NORMAL_PRIORITY_CLASS ; back to normal
    inv Sleep,0 
    mov eax,Min     ; return the minimum elapsed time
    .if DoingOverhead==0
        sub eax,OverHead
    .endif
endm
;----------------------------  SETUP --------------------------------------

    MAXWIDTH  equ 16
    HDRWIDTH  equ 11
    COLWIDTH  equ 5

;    %FOR proc,<Procs>
;        proc proto :dword,:dword
;    ENDM

    MaxStr=0
    scount=0
    %For T1,<Tests> ; get maximum string size
        if T1 GT MaxStr
            MaxStr=T1
        endif
        scount=scount+1
    ENDM

.data

align 16
Str1 db MaxStr+64 dup (0)      ; what will be input string1 to routines.  The extra 64 bytes are to represent
align 16                            ;   a possible next string in the real world that we would not want wiped out.
Str2 db MaxStr+64  dup (0)      ; what will be the answer returned from the routines
Str3 db MaxStr+64  dup (0)      ; what will be the correct answer to check the routines
    

align 16
Str1Offset      dd  0   ; offset to starting byte within String1 based upon number of extra bytes being tested
Str2Offset      dd  0   ; offset to starting byte within String2 based upon number of extra bytes being tested
Str1ZeroOffset  dd  0   ; computed offset to zero byte terminator of first string for each test
Str2ZeroOffset  dd  0   ; computed offset to zero byte terminator of second string
Str1Size        dd  0   ; for those routines that cheat by not computing this themselves
ErrorFound      dd  0   ; flag that an error was found processing a proc
Junk            dd  0   ; scrath place for mem protect  
.code
align 16

;Printing routines from Phil
sxFld proc DDpointer:DWORD, rvstring:DWORD, DDwidth:DWORD, DDalign:DWORD    
    .if DDalign == 0                    ; align left?
        invoke szLeft,DDpointer,rvstring,DDwidth
        invoke szLen,rvstring
        mov edx,rvstring
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+eax],32   ;space
        inc eax
        jmp @B
    @@: mov byte ptr [edx+eax],0
    .elseif DDalign == 1                ; align right?
        invoke szLen,DDpointer
        mov edx,rvstring
        xor ecx,ecx
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+ecx],32
        inc eax
        inc ecx
        jmp @B
    @@: add edx,ecx
        invoke szLeft,DDpointer,edx,DDwidth
    .endif
    ret 4*4
sxFld endp

fld$ MACRO DDpointer,DDwidth,DDalign:=<0>       ; Default is align left
    LOCAL rvstring
    .data
        rvstring db MAXWIDTH+4 dup (0)
        align 16
    .code
    invoke sxFld,reparg(DDpointer),ADDR rvstring,DDwidth,DDalign
    EXITM <ADDR rvstring>
ENDM

CheckForError proc  ; check result string for correctness.  return no carry=ok, carry set=error
    mov eax,PNamePtr    ; pointer to pNamePtr table
    mov eax,[eax]       ; pointer to address of name
    mov eax,[eax]       ; value at address
    cmp eax,0048564fh   ; "OVH"  check for overhead proc
    je AllOk
    ;String2 must equal String3.  
    mov esi,Str2Offset
    mov edi,offset Str3
    mov ecx,Str1Size
    inc ecx     ; the zero byte terminators must also match
@@: lodsb
    cmp al,[edi]
    stc     ; assume error
    jne CheckForErrorRet
    inc edi
    loop @b
AllOk:
    clc
CheckForErrorRet:
    ret
CheckForError EndP

;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
.data
 DoingOverhead dd 0
.code

align 16

start:
    pcount=1
    %for proc,<Procs>   ; count number of routines to test
        pcount=pcount+1
    endm
.data
    align 4
    ptable dd pcount dup (0)    ; table of proc addresses
    lastproc dd 0               ; address of last proc
    pname dd pcount dup (0)     ; table of addresses of proc names for printing
.code
    mov edx,offset ptable   ; address to call
    mov ecx,offset pname    ; address of ascii name of routines for printing
    %for proc,<Procs>
        mov eax,offset proc
        mov [edx],eax       ; save address of proc to call
        mov lastproc,edx    ; save ending condition for loops
        add edx,4
        ifndef &proc&name
.data
            &proc&name db "&proc&",0    ; save the proc names for headers
.code
        endif
        mov [ecx],offset &proc&name     ; save the address of the proc name for headers
        add ecx,4
    endm

.data
    T1s dd scount dup (0)       ; lengths of the test strings
    lastT1 dd 0                 ; address of last T1 to use
.code
    mov edx,offset T1s
    %FOR T1,<Tests> ; get sizes
        mov eax,T1
        mov [edx],eax
        mov lastT1,edx
        add edx,4
    ENDM

    ; Now move the actual code to test to a common postion so all tests have the same advantage
    mov ecx,MaximumProcSize
    mov edx,offset TheProc
    inv VirtualProtect,edx,ecx,PAGE_EXECUTE_READWRITE,addr Junk ; stupid invoke
    invoke GetCurrentProcess
    mov edx,MaximumProcSize
    mov ecx,offset TheProc
    invoke FlushInstructionCache,eax,ecx,edx    ; ditto
 
;   print out the headers
    print fld$(chr$("Str1 Size"),HDRWIDTH)

    mov ebx,offset T1s
    %FOR T1,<Tests>
        print fld$(chr$("&T1&"),COLWIDTH,1)
    ENDM
    print chr$(13,10)

    print fld$(chr$("====================="),HDRWIDTH)
    %FOR T1,<Tests>
        print fld$(" =====================",COLWIDTH)
    ENDM
    print chr$(13,10)


.data?
    extracount dd ? ; step through extra bytes
    PAddr      dd ? ; address of proc to call
    PTblPtr    dd ? ; address of proc within table
    PNamePtr   dd ? ; address of proc name within table
    TPtr       dd ? ; address of number of bytes in string 1 to create
    T1Siz      dd ? ; size of string 1
    TstCnt     dd ? ; number of times we have pre-tested
.code   
    ;FOR extra=0 to 3
    mov extracount,0    ; initialize loop
    ExtraLoop:
        print chr$(13,10)
        mov ecx,extracount
        print sstr$(ecx)
        print chr$(" byte misalignment",13,10)
        ;%FOR proc,<Procs>
        mov PTblPtr,offset ptable   ; initialize loop
        mov PNamePtr,offset pname
PrintText "starting procsloop"
        procsloop:
            mov eax,PTblPtr ; get address of routine to test
            mov eax,[eax]
            mov PAddr,eax
            mov eax,PNamePtr
            mov eax,[eax]
            mov ecx,[eax]
            cmp ecx,0048564fh   ; "OVH"  check for overhead proc
            jne @f
            mov DoingOverhead,1
    @@:
            print fld$(eax,HDRWIDTH)
           
           ; now move the proc to a standard location
PrintText "moving proc"
           mov esi,PAddr
           mov ecx,MaximumProcSize
           mov edi,offset TheProc
           rep movsb
           cpuid    ; flush
            ;%FOR T1,<Tests>
            mov TPtr,offset T1s ; initialize loop
PrintText "creating string"
            T1loop: 
                mov ecx,TPtr                ; get length of string 1
                mov eax,[ecx]
                mov T1Siz,eax
                mov Str1Size,eax            ; save for routines that require size as a parameter

                ; create fresh test strings for each routine to use 
                mov eax,offset Str1
                add eax,extracount          ; start of string1 for testing
                mov Str1Offset,eax
                add eax,T1Siz
                mov Str1ZeroOffset,eax      ; where zero byte terminator will be

                mov eax,offset Str2
                add eax,extracount          ; start of string2 for testing
                mov Str2Offset,eax
                add eax,T1Siz
                mov Str2ZeroOffset,eax     ; where zero byte terminator will be

                mov edi,offset Str1      ; create test string values
                mov ecx,MaxStr+48         ; leave bytes at end for accidents
                mov al,33

            @@: stosb
                add al,1                    ; step through all possible characters, skipping zeros.
                cmp al,0
                jne ok1
                add al,1
            ok1:
                sub ecx,1
                jnz @b
NoData:
                mov eax,Str1ZeroOffset
                mov [eax],byte ptr 0        ; set length of string
PrintText "creating answer"                
                mov esi,eax
                sub esi,1                   ; now create answer
                mov edi,offset Str3
                mov ecx,T1Siz
                cmp ecx,0
                je NoData2
            @@:
                mov eax,[esi]
                stosb
                dec esi
                dec ecx
                jnz @b
NoData2:
                xor eax,eax
                stosb                       ; save terminator           
                ; run several times to verify operation before running timing test
                mov TstCnt,3
PrintText "running pretest"
PreTest:
                mov esi,offset Str1
                mov edi,offset Str2     ; make a duplicate for those routines that work in place
                mov ecx,(MaxStr+48)/4   ; leave extra bytes at end for accidents
                rep movsd
;               push Str2Offset         ;simulate invoke proc,Str1Offset,Str2Offset
;               push Str1Offset
PrintText "calling the proc"
                call TheProc
PrintText "checking for error"
                call CheckForError
                jc NoGood                   ; error in routine
                sub TstCnt,1
                jnz PreTest
                
PrintText "doing actual test"
                ; now do actual time test
                BeginCounter
                    mov esi,offset Str1		; make a duplicate for those routines that work in place
                    mov edi,offset Str2     
	                mov ecx,(MaxStr+48)/4   ; leave extra bytes at end for accidents
	                rep movsd
    ;               push Str2Offset         ;simulate invoke proc,Str1Offset,Str2Offset
    ;               push Str1Offset
                    call TheProc
                EndCounter
PrintText "done with test"                
                cmp DoingOverhead,1
                jne @f
                mov OverHead,eax
                mov DoingOverhead,0
@@:
                push eax        ; save timing results
                call CheckForError  ; and one more check to be sure everything is still ok
                pop ebx     ; get back results
                jc NoGood
PrintText "printing answer"             
                print fld$(sstr$(ebx),COLWIDTH,1)
                jmp NextTPtr
NoGood:                
                print fld$("fail",COLWIDTH,1)            
NextTPtr:                
            ;ENDM
            add TPtr,4
            mov eax,TPtr
            cmp eax,lastT1
            jbe T1loop
            print chr$(13,10)
        ;ENDM
        add PNamePtr,4
        add PTblPtr,4
        mov eax,PTblPtr
        cmp eax,lastproc
        jbe procsloop        
    ;ENDM
    add extracount,1
    cmp extracount,3    ; doing 0-3 extra bytes
    jbe ExtraLoop
    mov   eax,input(13,10,"Press enter to exit...")
    exit


;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
; --------------------- Routines under test ---------------------------------------------
;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------

;--------  All routines must be written with the same call  ------- 


ProcMaxSize=0
;---------------All routines must be surrounded by this code-----------------------------

;---------------------------- Routine 0 ----------------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------

ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

;---------------------------- Routine 1 ----------------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------
CopyTest proc 
    push esi
    push edi
    mov esi,offset Str3
    mov edi,Str2Offset
    mov ecx,Str1Size
    shr ecx,2
    inc ecx
    rep movsd
    pop esi
    pop edi
	ret
CopyTest EndP
ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif


;---------------------------- Routine 12D  --------------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------
Jimg6 proc		; modified to write to input buffer  (reverse in place)
    mov eax,Str2Offset  ; Start of string
    mov ecx,Str1Size	; will be offset from right
    cmp ecx,5
    jl  LessThan5Bytes	; assumes zero byte terminator already in place
    sub ecx,4		; offset from eax to last dword of string
    push ebx
	jmp @f
	align 16
@@:
    mov edx,[eax]
	mov ebx,[eax+ecx]
    bswap edx
    bswap ebx
    mov [eax+ecx],edx
    mov [eax],ebx
    add eax,4
    sub ecx,8
    jg  @b

align 4
	add ecx,4		; get count of chars left
    pop ebx
    
LessThan5Bytes:	
            ; possible input    0    a     ab     abc   abcd
            ;            ecx=   0    1      2      3      4
            ; currrent output   ???? a???  ab??   abc?  abcd
            ;  eax = offset of first byte to do

	cmp ecx,4
	je Do4
	cmp ecx,3
	je Do3
	cmp ecx,2
	jne EndIt	;1 or zero, all done
Do2:
	mov dx,[eax]	; ab??
	mov [eax],dh	; bb??
	mov [eax+1],dl	; ba??
	ret
Do3:
	mov dl,[eax]	; abc?
	mov dh,[eax+2]
	mov [eax+2],dl	; aba?
	mov [eax],dh	; cba?
	ret
Do4:
    mov edx,[eax]	; abcd
    bswap edx
    mov [eax],edx	; dcba
EndIt:
	ret
Jimg6 endp        

ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

;---------------------------- Routine 14 ----------------------------------
align 16
PStart = $

; --------------  Routine goes here --------------------------------------
ALIGN 16
UltimateStringReverse PROC ;StrAddr:DWORD,StrSize:DWORD
	push esi
	push edi
	
	mov esi,Str2Offset
	mov eax,Str1Size
	lea edi,[esi+eax-2]
	shr eax,1
	sub edi,eax	; = esi+eax-2-(eax/2) = esi + eax/2 -2 
	add eax,-2	
	js Label2
Label1:
	mov ecx,DWORD PTR [esi]
	mov edx,DWORD PTR [edi+eax]
	bswap ecx
	bswap edx
	mov DWORD PTR [edi+eax],ecx
	mov DWORD PTR [esi],edx
	add esi,4
	add eax,-4
	jns Label1
Label2:
	cmp eax,-1
	jne Label3
	mov cl,BYTE PTR [edi+2]
	mov ch,BYTE PTR [esi]
	mov BYTE PTR [edi+2],ch
	mov BYTE PTR [esi],cl
Label3:
	pop edi
	pop esi
	ret
UltimateStringReverse ENDP
ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

;---------------------------- Routine 15 ----------------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------

ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif


;-------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
; --------------------- End of Routines under test --------------------------------------
;----------------------------------------------------------------------------------------
align 16
PStart = $
OVH proc ;xStr1:dword, xstr2:dword
   ret ;8
OVH EndP 
ProcSize=$-PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
.data
MaximumProcSize dd ProcMaxSize
.code


;--------------------------  procs will be moved to here for testing  ------------------------------------
align 16
TheProc:
db ProcMaxSize+64 dup (0)

;-------------------------------------------------------------------------------

end start
